#! /usr/bin/python3

import os, os.path
import sqlite3
from datetime import datetime

class History:
    def __init__(self, jolla=os.getenv("HOME")):
        dbfile = os.path.join(jolla, ".local/share/commhistory/commhistory.db")
        self._db = sqlite3.connect(dbfile)
    
    def list(self, filter=None):
        cursor = self._db.cursor()
        
        query = """
SELECT startTime, endTime, direction, remoteUid
FROM Events
WHERE type = '3'
        """
        
        if filter is None:
            results = cursor.execute(query)
        else:
            query  += "AND remoteUid LIKE ?"
            results = cursor.execute(query, ["%" + filter + "%"])
        
        for (startTime, endTime, direction, remoteUid) in results:
            c = {}
            c["startTime"] = datetime.fromtimestamp(startTime)
            c["endTime"]   = datetime.fromtimestamp(endTime)
            c["remoteUid"] = remoteUid
            if direction == 2:
                c["direction"] = "out"
            elif direction == 1:
                c["direction"] = "in"
            else:
                raise Exception("Invalid direction", direction)
            
            yield c

